'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _Request = require('./util/Request');

var _Request2 = _interopRequireDefault(_Request);

var _Utils = require('./util/Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _Events = require('./util/Events');

var _Events2 = _interopRequireDefault(_Events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Option = _antd.Select.Option;

var DeviceCombox = function (_React$Component) {
    _inherits(DeviceCombox, _React$Component);

    function DeviceCombox() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, DeviceCombox);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DeviceCombox.__proto__ || Object.getPrototypeOf(DeviceCombox)).call.apply(_ref, [this].concat(args))), _this), _this.project = {}, _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(DeviceCombox, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var url = this.props.url;
            _Request2.default.get(url, null, this.getDataSuccess, this);
        }
    }, {
        key: 'getDataSuccess',
        value: function getDataSuccess(value) {
            if (!_Utils2.default.isSuccess(value)) return;
            this.setState({ values: value.data });
            this.project = value.data[0];
            _Events2.default.emit('reloadListBar', { projectId: this.project.id });
            _Events2.default.emit('reloadMapSite', this.project);
        }
    }, {
        key: 'handleChange',
        value: function handleChange(value) {
            var _this2 = this;

            this.state.values.forEach(function (data) {
                if (data.id == value) {
                    _this2.project = data;
                }
            });
            _Events2.default.emit('reloadListBar', { projectId: this.project.id });
            _Events2.default.emit('resetFields');
            _Events2.default.emit('reloadMapSite', this.project);
        }
    }, {
        key: 'render',
        value: function render() {
            var combox = { width: '100%', marginBottom: '10px' };
            var values = this.state.values;
            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                    _antd.Select,
                    { placeholder: values != null ? values[0].name : null, style: combox, onChange: this.handleChange.bind(this) },
                    values != null ? values.map(function (data) {
                        return _react2.default.createElement(
                            Option,
                            { key: data.id, value: data.id },
                            data.name
                        );
                    }) : null
                )
            );
        }
    }]);

    return DeviceCombox;
}(_react2.default.Component);

exports.default = DeviceCombox;