'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _Utils = require('./util/Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _Request = require('./util/Request');

var _Request2 = _interopRequireDefault(_Request);

var _Events = require('./util/Events');

var _Events2 = _interopRequireDefault(_Events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require("./Main.css");
var FormItem = _antd.Form.Item;
var Option = _antd.Select.Option;
// const { Option, OptGroup } = Select;

var DeviceDetil = function (_React$Component) {
    _inherits(DeviceDetil, _React$Component);

    function DeviceDetil() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, DeviceDetil);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DeviceDetil.__proto__ || Object.getPrototypeOf(DeviceDetil)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            isEdit: false,
            isFlyTo: true,
            rotateAngle: null,
            innerInfoData: []
        }, _this.locked = false, _this.resetObj = null, _this.firstFloorId = null, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(DeviceDetil, [{
        key: 'componentWillMount',
        value: function componentWillMount() {}
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.initDetailDataFn = this.initDetailDataCall.bind(this);
            _Events2.default.addListener('reloadDetail', this.initDetailDataFn);
            this.mateModuleFn = this.mateModule.bind(this);
            _Events2.default.addListener('mateModule', this.mateModuleFn);
            this.saveModuleDataFn = this.saveModuleData.bind(this);
            _Events2.default.addListener('saveModuleData', this.saveModuleDataFn);
            this.resetFieldsFn = this.resetFields.bind(this);
            _Events2.default.addListener('resetFields', this.resetFieldsFn);
            this.removeModuleFn = this.removeModule.bind(this);
            _Events2.default.addListener('removeModuleData', this.removeModuleFn);
            this.getOptionDataFn = this.getOptionData.bind(this);
            _Events2.default.addListener('getOptionData', this.getOptionDataFn);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            _Events2.default.removeListener('reloadDetail', this.initDetailDataFn);
            _Events2.default.removeListener('removeModuleData', this.removeModuleFn);
            _Events2.default.removeListener('resetFields', this.resetFieldsFn);
            _Events2.default.removeListener('saveModuleData', this.saveModuleDataFn);
            _Events2.default.removeListener('mateModule', this.mateModuleFn);
            _Events2.default.removeListener('getOptionData', this.getOptionDataFn);
            this.locked = true;
        }
    }, {
        key: 'initDetailDataCall',
        value: function initDetailDataCall(config) {
            if (!this.locked) {
                this.setState({ isEdit: false });
                this.initDetailData(config);
            }
        }
    }, {
        key: 'doSubmit',
        value: function doSubmit(earth) {
            var _this2 = this;

            var me = this;
            var reg = /^[^\s]*$/;
            var reg_1 = /^[^.();<>]*$/;
            if (me.formData['position']) {
                if (me.formData['position'].length > 20) {
                    _Utils2.default.error("设备位置长度不能超过20！");
                    return;
                }
                if (!reg.test(me.formData['position'])) {
                    _Utils2.default.error("设备位置不能包含空格！");
                    return;
                }
                if (!reg_1.test(me.formData['position'])) {
                    _Utils2.default.error("设备位置不能特殊字符！");
                    return;
                }
            }
            if (me.formData['x'] * 1 + "" == "NaN") {
                _Utils2.default.error("经度栏请输入正确数字");
                return;
            }
            if (me.formData['y'] * 1 + "" == "NaN") {
                _Utils2.default.error("纬度栏请输入正确数字");
                return;
            }
            if (me.formData['z'] * 1 + "" == "NaN") {
                _Utils2.default.error("高度栏请输入正确数字");
                return;
            }
            if (me.formData['deviceAngle']) {
                if (me.formData['deviceAngle'] * 1 + "" == "NaN") {
                    _Utils2.default.error("设备角度只能为数值");
                    return;
                }
            }
            if (me.formData['scalingRatio']) {
                if (me.formData['scalingRatio'] * 1 + "" == "NaN") {
                    _Utils2.default.error("设备缩放比例只能为数值");
                    return;
                }
            }
            me.formProps.form.validateFields(function (err, values) {
                if (!_Utils2.default.isEmpty(err)) return;
                var param = {};
                Object.keys(me.formData).map(function (k) {
                    param[k] = me.formData[k];
                });
                if (!earth) {
                    var m = window.earth.Api.Layers.getLayer(param.objType).getModel(param.id);
                    var point = new window.earth.Api.Type.Point(parseFloat(param.x), parseFloat(param.y), parseFloat(param.z));
                    point.changeEPSGType('3857');
                    m.setPosition(point);
                    m.userData.repeat_rate = param.scalingRatio + ',' + param.scalingRatio + ',' + param.scalingRatio;
                    m.userData.angle = param.deviceAngle;
                    m.userData.pid = param.pid;
                    if (param.deviceAreaType == "public") {
                        m.userData.type = 1;
                    } else {
                        m.userData.type = 0;
                    }
                    var select = window.earth.getControl('SelectControl');
                    select.doUnSelect();
                    select.doSelect({ object: m, point: m.position.clone() });
                    window.earth.Api.MeshInfo.doEdit();
                } else {
                    var url = me.props.save_url;
                    _Request2.default.post(url, param, null, me.callbackSubmit.bind(_this2), me);
                }
            });
            this.setState({ isEdit: false, readonly: true });
            this.props.parent.lastAddModel = undefined;
            this.props.parent.creatPop = false;
            this.props.parent.setModel = undefined;
            window.earth.Api.MeshInfo.endMove();
            window.earth.Api.Pop.clear(this.formData.objType, this.formData.id);
        }
    }, {
        key: 'callbackSubmit',
        value: function callbackSubmit(data) {
            if (_Utils2.default.isSuccess(data)) {
                _Utils2.default.success('保存成功!');
                this.resetObj = _extends({}, this.formData);
                _Events2.default.emit('reloadListBar');
            } else {
                _Utils2.default.error('保存失败!');
            };
        }
    }, {
        key: 'removeModule',
        value: function removeModule() {
            var me = this;
            var url = me.props.delete_url;
            var params = new FormData();
            params.append('id', me.formData['id']);
            params.append('tableName', me.formData['table_name']);
            _Request2.default.post(url, params, null, me.callbackDelete, me);
        }
    }, {
        key: 'callbackDelete',
        value: function callbackDelete(data) {
            if (_Utils2.default.isSuccess(data)) {
                _Utils2.default.success('删除成功!');
                this.formData = {};
                this.props.parent.setState({ current: [] });
                this.props.parent.lastAddModel = undefined;
            } else {
                _Utils2.default.error('删除失败!');
            };
            this.resetFields();
            _Events2.default.emit('reloadListBar');
        }
    }, {
        key: 'resetFields',
        value: function resetFields() {
            this.formProps.form.resetFields();
        }
    }, {
        key: 'resetForm',
        value: function resetForm() {
            var value = {};
            var obj = this.resetObj;
            value['position'] = obj.position;
            value['x'] = obj.x ? parseFloat(obj.x).toFixed(6) : null;
            value['y'] = obj.y ? parseFloat(obj.y).toFixed(6) : null;
            value['z'] = obj.z ? parseFloat(obj.z).toFixed(2) : null;
            value['deviceAngle'] = obj.deviceAngle;
            value['scalingRatio'] = obj.scalingRatio;
            this.formProps.form.setFieldsValue(value);
        }
    }, {
        key: 'saveModuleData',
        value: function saveModuleData(position) {
            var value = {};
            value['x'] = position.x;
            value['y'] = position.y;
            value['z'] = position.z;
            this.formProps.form.setFieldsValue(value);
            this.doSubmit(true);
        }
    }, {
        key: 'mateModule',
        value: function mateModule(geo) {
            if (!this.locked) {
                this.setState({ isEdit: false, readonly: true });
                var point = new window.earth.Api.Type.Point(geo.position.x, geo.position.y, geo.position.z, '3857');
                point.changeEPSGType('4326');
                var config = {
                    id: geo.userData.id,
                    objType: geo.parent.userData.objType,
                    x: point.x,
                    y: point.y,
                    z: point.z,
                    deviceAngle: geo.userData.angle,
                    scalingRatio: geo.userData.repeat_rate.split(",")[0]
                };
                this.setState({ isFlyTo: false });
                this.initDetailData(config);
                this.props.parent.setState({
                    openKeys: [geo.parent.userData.objType],
                    current: [geo.userData.id]
                });
                this.props.parent.onSearch = false;
                var layer = document.getElementById(geo.parent.userData.objType + '$Menu');
                if (layer == undefined) {
                    _Utils2.default.alert('请重新选择设备类型');
                } else {
                    var layerList = layer.getElementsByClassName('ant-menu-item-selected')[0];
                    var i = 0;
                    while ((layerList = layerList.previousSibling) != null) {
                        i++;
                    }layer.scrollTo(0, i * 35);
                }
                _Events2.default.emit('reloadListBar');
            }
        }
    }, {
        key: 'initDetailData',
        value: function initDetailData(config) {
            var url = this.props.url;
            for (var key in config) {
                var v = config[key];
                if (!_Utils2.default.isEmpty(v)) url += '&' + key + '=' + v;
            }
            _Request2.default.get(url, null, this.getDataSuccess.bind(this, config), this);
        }
    }, {
        key: 'getDataSuccess',
        value: function getDataSuccess(config, value) {
            if (!this.locked) {
                if (!_Utils2.default.isSuccess(value)) return;
                var module_data = value.data;
                if (!module_data) {
                    _Utils2.default.alert('无相关数据!');
                    return;
                }
                _extends(value.data, config);
                this.formData = value.data || {};
                if (_Utils2.default.isEmpty(this.formData['deviceAngle'])) {
                    this.formData['deviceAngle'] = 0;
                }
                if (_Utils2.default.isEmpty(this.formData['scalingRatio'])) {
                    this.formData['scalingRatio'] = 1;
                }
                this.resetObj = _extends({}, this.formData);
                this.setState({ rotateAngle: value.data.deviceAngle });
                this.setState({ readonly: true });
                this.onFieldsChange(null, null);
                if (this.state.isFlyTo == true) {
                    _Events2.default.emit('isAddModule', module_data);
                } else {
                    this.setState({ isFlyTo: true });
                }
            }
            window.earth.Api.MeshInfo.endMove();
        }
    }, {
        key: 'getOptionData',
        value: function getOptionData(innerInfo) {
            this.setState({ innerInfoData: innerInfo.values });
        }
    }, {
        key: 'creatOption',
        value: function creatOption() {
            var _this3 = this;

            var listData = this.state.innerInfoData;
            return listData.map(function (ele) {
                if (ele.high == "0") {
                    _this3.firstFloorId = ele.id;
                }
                return _react2.default.createElement(
                    Option,
                    { key: ele.id, value: ele.id },
                    '\u5BB6\u5EAD\u533A\u57DF-',
                    ele.name
                );
            });
        }
    }, {
        key: 'mapPropsToFields',
        value: function mapPropsToFields() {
            var _this4 = this;

            if (!this.formData) {
                this.formData = this.initFormData();
            }
            _extends(this.formData);
            var config = {};
            Object.keys(this.formData).map(function (k) {
                if (k == 'x' || k == 'y') {
                    _this4.formData[k] = (_this4.formData[k] * 1).toFixed(6);
                } else if (k == 'z' || k == 'scalingRatio') {
                    _this4.formData[k] = (_this4.formData[k] * 1).toFixed(2);
                }
                config[k] = _antd.Form.createFormField({ value: _this4.formData[k] });
            });
            return config;
        }
    }, {
        key: 'initFormData',
        value: function initFormData() {
            return {};
        }
    }, {
        key: 'onValuesChange',
        value: function onValuesChange(_, values) {
            _extends(this.formData, values);
        }
    }, {
        key: 'onFieldsChange',
        value: function onFieldsChange(props, changedFields) {}
    }, {
        key: 'initForm',
        value: function initForm() {
            var _this5 = this;

            var cfg = {
                onFieldsChange: this.onFieldsChange.bind(this),
                mapPropsToFields: this.mapPropsToFields.bind(this),
                onValuesChange: this.onValuesChange.bind(this)
            };
            var CustomizedForm = _antd.Form.create(cfg)(function (props) {
                _this5.initRuleConfig(props);
                _this5.initRuleFunc(props);
                _this5.formProps = props;
                return _this5.initDetail(props);
            });
            return _react2.default.createElement(CustomizedForm, null);
        }
    }, {
        key: 'doEdit',
        value: function doEdit() {
            if (!this.locked) {
                this.setState({ isEdit: true, readonly: false });
            }
            if (this.props.parent.setModel) {
                var point = null;
                var ele = this.props.parent.setModel;
                if (_Utils2.default.isEmpty(ele.x) || _Utils2.default.isEmpty(ele.y) || _Utils2.default.isEmpty(ele.z)) {
                    point = window.earth.Api.Camera.info().target;
                    point.z = 50;
                } else {
                    point = new window.earth.Api.Type.Point(ele.x * 1, ele.y * 1, ele.z * 1);
                }
                var shapes = [];
                var cfg = {};
                shapes = [point];
                cfg = {
                    data: {
                        id: ele.id,
                        fbx: './images/equipment/' + ele.objType + '.fbx',
                        angle: "0",
                        repeat_rate: "1,1,1",
                        rotatex: "1"
                    },
                    jsType: "Fbx",
                    shapes: shapes
                };
                var fbx = new window.earth.Api.Models.Fbx(cfg, earth);
                var layer = window.earth.Api.Layers.getLayer(ele.objType);
                this.props.parent.lastAddModel = {
                    objType: ele.objType,
                    id: ele.id
                };
                layer.add(fbx);
                setTimeout(function () {
                    if (earth) {
                        fbx.changeColor('#fff900');
                        window.earth.Api.Camera.lookAt(ele.objType, ele.id, false);
                    }
                }, 1000);
            }
            this.props.parent.creatPop = true;
            var me = this;
            window.earth.on('MeshHover', function (ele) {
                if (ele.userData.id == me.formData.id && me.props.parent.creatPop) {
                    window.earth.Api.Pop.setObjPop(ele.parent.userData.objType, ele.userData.id, function (result) {
                        result.innerHTML = '<div class="gis-modelPop"><span>请拖动设备到目标位置</span><i></i></div>';
                    });
                    window.earth.Api.Pop.display(ele.parent.userData.objType, ele.userData.id, true);
                }
                if (document.querySelector('.gis-modelPop')) {
                    document.querySelector('.gis-modelPop').parentNode.style.cssText += 'pointer-events: none;';
                }
            });
            window.earth.on('MeshUnHover', function (ele) {
                if (ele.userData.id == me.formData.id && me.props.parent.creatPop) {
                    window.earth.Api.Pop.clear(ele.parent.userData.objType, ele.userData.id);
                }
            });
            window.earth.Api.MeshInfo.doMove(false);
        }
    }, {
        key: 'changeType',
        value: function changeType(value) {
            if (value !== "public") {
                this.formData['deviceAreaType'] = "house";
                this.formData['pid'] = value;
            } else {
                this.formData['deviceAreaType'] = value;
                this.formData['pid'] = this.firstFloorId;
            }
        }
    }, {
        key: 'changePosition',
        value: function changePosition(data) {
            var m = window.earth.Api.Layers.getLayer(this.formData['objType']).getModel(this.formData['id']);
            var point = new window.earth.Api.Type.Point(parseFloat(this.formData['x']), parseFloat(this.formData['y']), parseFloat(this.formData['z']));
            point.changeEPSGType('3857');
            m.setPosition(point);
            if (data == 'deviceAngle') {
                var angle = this.formData['deviceAngle'] * 1;
                var beforeAngle = void 0;
                if (this.state.rotateAngle) {
                    beforeAngle = this.state.rotateAngle * 1;
                } else {
                    beforeAngle = 0;
                }
                if (angle >= 0 && angle <= 360 && Math.floor(angle) === angle) {
                    var value = (angle - beforeAngle) * Math.PI / 180;
                    this.setState({ rotateAngle: this.formData['deviceAngle'] });
                    m.rotateY(value);
                } else {
                    _Utils2.default.error("设备角度为0度至360度之间的整数");
                    return;
                }
            }
            if (data == 'scalingRatio') {
                var rate = this.formData['scalingRatio'] * 1;
                m.scale.set(rate, rate, rate);
            }
        }
    }, {
        key: 'changeProperty',
        value: function changeProperty(field, e) {
            if (field == 'x') {
                if (e.target.value * 1 + "" != "NaN") {
                    this.changePosition();
                } else {
                    _Utils2.default.error("请输入数值");
                    return;
                }
            } else if (field == 'y') {
                if (e.target.value * 1 + "" != "NaN") {
                    this.changePosition();
                } else {
                    _Utils2.default.error("请输入数值");
                    return;
                }
            } else if (field == 'z') {
                if (e.target.value * 1 + "" != "NaN") {
                    this.changePosition();
                } else {
                    _Utils2.default.error("请输入数值");
                    return;
                }
            } else if (field == 'deviceAngle') {
                if (e.target.value * 1 + "" != "NaN") {
                    this.changePosition('deviceAngle');
                } else {
                    _Utils2.default.error("请输入数值");
                    return;
                }
            } else if (field == 'scalingRatio') {
                if (e.target.value * 1 + "" != "NaN") {
                    this.changePosition('scalingRatio');
                } else {
                    _Utils2.default.error("请输入数值");
                    return;
                }
            }
        }
    }, {
        key: 'setDefault',
        value: function setDefault() {
            if (this.formData['deviceAreaType'] == "house") {
                return this.formData["pid"];
            } else {
                return this.formData['deviceAreaType'];
            }
        }
    }, {
        key: 'initDetail',
        value: function initDetail(props) {
            var initFieldStates = props.form.initFieldStates;

            return _react2.default.createElement(
                'section',
                { style: { padding: 24 } },
                _react2.default.createElement(
                    _antd.Form,
                    { className: this.state.isEdit == false ? 'gis-editState' : 'gis-saveState' },
                    _react2.default.createElement(
                        _antd.Row,
                        null,
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 4 },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                initFieldStates('name', { dom: _antd.Input, style: { width: 210, height: 28 } })
                            )
                        )
                    ),
                    _react2.default.createElement(
                        _antd.Row,
                        null,
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 5 },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u4EA7\u54C1\u540D\u79F0\uFF1A'
                                ),
                                initFieldStates('productName', { dom: _antd.Input, style: { width: 210, height: 28 } })
                            )
                        ),
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 10 },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u8BBE\u5907ID\uFF1A'
                                ),
                                initFieldStates('id', { dom: _antd.Input, style: { width: 300, height: 28 } })
                            )
                        ),
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 9 },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u8BBE\u5907\u4F4D\u7F6E\uFF1A'
                                ),
                                _react2.default.createElement(
                                    _antd.Select,
                                    { defaultValue: this.setDefault(), id: 'deviceAreaType', onChange: this.changeType.bind(this), dropdownClassName: 'areaType', disabled: this.state.isEdit == false ? true : false },
                                    _react2.default.createElement(
                                        Option,
                                        { value: 'public' },
                                        '\u516C\u5171\u533A\u57DF'
                                    ),
                                    this.creatOption()
                                ),
                                _react2.default.createElement(
                                    'span',
                                    { id: 'selectLink' },
                                    '-'
                                ),
                                initFieldStates('position', { dom: _antd.Input, style: { width: '45%', height: 28 } })
                            )
                        )
                    ),
                    _react2.default.createElement(
                        _antd.Row,
                        null,
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 5 },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u7ECF\u5EA6\uFF1A'
                                ),
                                _react2.default.createElement(
                                    'div',
                                    { onBlur: this.changeProperty.bind(this, 'x') },
                                    initFieldStates('x', { dom: _antd.Input, style: { width: '80%', height: 28 } })
                                )
                            )
                        ),
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 5 },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u7EAC\u5EA6\uFF1A'
                                ),
                                _react2.default.createElement(
                                    'div',
                                    { onBlur: this.changeProperty.bind(this, 'y') },
                                    initFieldStates('y', { dom: _antd.Input, style: { width: '80%', height: 28 } })
                                )
                            )
                        ),
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 5 },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u9AD8\u5EA6\uFF1A'
                                ),
                                _react2.default.createElement(
                                    'div',
                                    { onBlur: this.changeProperty.bind(this, 'z') },
                                    initFieldStates('z', { dom: _antd.Input, style: { width: '80%', height: 28 } })
                                )
                            )
                        ),
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 5, style: { width: '16.87%' } },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u8BBE\u5907\u89D2\u5EA6\uFF1A'
                                ),
                                _react2.default.createElement(
                                    'div',
                                    { onBlur: this.changeProperty.bind(this, 'deviceAngle') },
                                    initFieldStates('deviceAngle', { dom: _antd.Input, style: { width: '100%', height: 28 } })
                                )
                            )
                        ),
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 4, style: { width: '16.9%', marginLeft: '15.6px' } },
                            _react2.default.createElement(
                                FormItem,
                                null,
                                _react2.default.createElement(
                                    'label',
                                    { className: 'gis-formLabel' },
                                    '\u7F29\u653E\u6BD4\u4F8B\uFF1A'
                                ),
                                _react2.default.createElement(
                                    'div',
                                    { onBlur: this.changeProperty.bind(this, 'scalingRatio') },
                                    initFieldStates('scalingRatio', { dom: _antd.Input, style: { width: '100%', height: 28 } })
                                )
                            )
                        )
                    ),
                    _react2.default.createElement(
                        _antd.Row,
                        null,
                        _react2.default.createElement(
                            _antd.Col,
                            { span: 4, offset: 20, style: { marginLeft: '80.7%', textAlign: 'right' } },
                            this.state.isEdit == false ? _react2.default.createElement(
                                _antd.Button,
                                { type: 'primary', onClick: this.doEdit.bind(this), className: 'gis-editButton' },
                                '\u7F16\u8F91'
                            ) : null,
                            this.state.isEdit == true ? _react2.default.createElement(
                                'div',
                                null,
                                _react2.default.createElement(
                                    _antd.Button,
                                    { type: 'primary', onClick: this.doSubmit.bind(this, false), className: 'gis-saveButton' },
                                    '\u4FDD\u5B58'
                                ),
                                _react2.default.createElement(
                                    _antd.Button,
                                    { onClick: this.resetForm.bind(this), className: 'gis-resetButton' },
                                    '\u91CD\u7F6E'
                                )
                            ) : null
                        )
                    )
                )
            );
        }
    }, {
        key: 'initRuleConfig',
        value: function initRuleConfig(props) {
            props.form.rules = {};
            if (this.state.readonly == true) {
                props.form.rules['name'] = {};
                props.form.rules['name']['readonly'] = 1;
                props.form.rules['productName'] = {};
                props.form.rules['productName']['readonly'] = 1;
                props.form.rules['id'] = {};
                props.form.rules['id']['readonly'] = 1;
                props.form.rules['position'] = {};
                props.form.rules['position']['readonly'] = 1;
                props.form.rules['x'] = {};
                props.form.rules['x']['readonly'] = 1;
                props.form.rules['y'] = {};
                props.form.rules['y']['readonly'] = 1;
                props.form.rules['z'] = {};
                props.form.rules['z']['readonly'] = 1;
                props.form.rules['deviceAngle'] = {};
                props.form.rules['deviceAngle']['readonly'] = 1;
                props.form.rules['scalingRatio'] = {};
                props.form.rules['scalingRatio']['readonly'] = 1;
            } else {
                props.form.rules['name'] = {};
                props.form.rules['name']['readonly'] = 1;
                props.form.rules['productName'] = {};
                props.form.rules['productName']['readonly'] = 1;
                props.form.rules['id'] = {};
                props.form.rules['id']['readonly'] = 1;
            }
        }
    }, {
        key: 'initRuleFunc',
        value: function initRuleFunc(props) {
            var getFieldDecorator = props.form.getFieldDecorator;

            props.form['initFieldStates'] = function (field, cls) {
                var rule = props.form.rules[field];
                var allowblank = rule != null ? rule.allowblank : 0;
                var readonly = rule != null ? rule.readonly : 0;

                return getFieldDecorator(field, {
                    rules: [{ required: allowblank == 1, message: '字段不能为空' }]
                })(_react2.default.createElement(cls.dom, _extends({ style: cls.style, disabled: readonly == 1 }, cls.cfg)));
            };
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                null,
                this.initForm()
            );
        }
    }]);

    return DeviceDetil;
}(_react2.default.Component);

exports.default = DeviceDetil;