'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _Request = require('./util/Request');

var _Request2 = _interopRequireDefault(_Request);

var _Utils = require('./util/Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _Events = require('./util/Events');

var _Events2 = _interopRequireDefault(_Events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require("./Main.css");
var SubMenu = _antd.Menu.SubMenu;

var DeviceListBar = function (_React$Component) {
    _inherits(DeviceListBar, _React$Component);

    function DeviceListBar() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, DeviceListBar);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DeviceListBar.__proto__ || Object.getPrototypeOf(DeviceListBar)).call.apply(_ref, [this].concat(args))), _this), _this.layerList = [], _this.filesResult = [], _this.onSearch = false, _this.locked = false, _this.state = {
            deviceName: '',
            projectId: ''
        }, _this.isCheck = false, _this.objPid = null, _this.onChangeModuleName = function (e) {
            if (!_this.locked) {
                _this.setState({
                    deviceName: e.target.value,
                    isClear: true
                });
            }
        }, _this.onOpenChange = function (openKeys) {
            if (!_this.locked) {
                var latestOpenKey = openKeys.find(function (key) {
                    return _this.props.parent.state.openKeys.indexOf(key) === -1;
                });
                _this.props.parent.setState({
                    openKeys: [latestOpenKey]
                });
            }
        }, _this.handleClick = function (e) {
            var lastAddModel = _this.props.parent.lastAddModel;
            if (!_Utils2.default.isEmpty(lastAddModel)) {
                var id = lastAddModel.id;
                var objType = lastAddModel.objType;
                var layer = window.earth.Api.Layers.getLayer(objType);
                layer.remove(layer.getModel(id));
            }
            if (!_this.locked) {
                _this.props.parent.setState({ current: [e.key] });
                var config = {
                    id: e.key,
                    tableName: e.item.props.as,
                    objType: e.keyPath[e.keyPath.length - 1],
                    productName: e.item.props.name,
                    pid: e.item.props.type
                };
                _Events2.default.emit('reloadDetail', config);
            }
            _this.props.parent.creatPop = false;
            earth.Api.Menus.clear();
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(DeviceListBar, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (!this.locked) {
                this.state = { openKeys: [], current: [], projectId: this.props.projectId, pageCurrent: 1 };
                this.storeConfig = { start: 0, limit: 5 };
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.reloadDataCallFn = this.reloadDataCall.bind(this);
            _Events2.default.addListener('reloadListBar', this.reloadDataCallFn);
            this.setModuleStateFn = this.setModuleState.bind(this);
            _Events2.default.addListener('setModuleState', this.setModuleStateFn);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            _Events2.default.removeListener('setModuleState', this.setModuleStateFn);
            _Events2.default.removeListener('reloadListBar', this.reloadDataCallFn);
            this.locked = true;
        }
    }, {
        key: 'reloadDataCall',
        value: function reloadDataCall(config) {
            if (!this.locked) {
                if (config == null) {
                    this.reloadData({ projectId: this.state.projectId });
                } else {
                    this.reloadData(config);
                    this.setState({ projectId: config.projectId });
                }
            }
        }
    }, {
        key: 'reloadData',
        value: function reloadData(config) {
            if (this.props.parent.onSearch) {
                if (_Utils2.default.isEmpty(config.deviceName)) {
                    _Utils2.default.alert('请输入设备名称');
                    return;
                }
                if (_Utils2.default.isNull(config.deviceName)) {
                    _Utils2.default.alert('请输入设备名称');
                    return;
                }
            }
            if (config.deviceName) {
                config.deviceName = config.deviceName.replace(/(^\s*)|(\s*$)/g, "");
            }
            var url = this.props.url;
            if (!_Utils2.default.isEmpty(config)) {
                _extends(this.storeConfig, config);
            }
            for (var key in this.storeConfig) {
                var v = this.storeConfig[key];
                if (!_Utils2.default.isEmpty(v)) url += '&' + key + '=' + v;
            }
            _Request2.default.get(url, null, this.getDataSuccess, this);
        }
    }, {
        key: 'getDataSuccess',
        value: function getDataSuccess(value) {
            if (!_Utils2.default.isSuccess(value)) {
                _Events2.default.emit('errorTips');
                return;
            }
            value.data.forEach(function (ele) {
                for (var i = 0; i < ele.children.length; i++) {
                    ele.children[i].objType = ele.objType;
                    ele.children[i].productName = ele.name;
                }
                this.layerList.push(ele.objType);
            }, this);
            this.filesResult = value.data;
            this.props.parent.layerList = this.layerList;
            this.getObjTypeList();
            if (this.props.parent.initialize) this.initializePage();
            this.onChangePage(1);
        }
    }, {
        key: 'initializePage',
        value: function initializePage() {
            if (!this.locked) {
                var layer = window.earth.Api.Layers.getLayer(this.filesResult[0].objType);
                var firstModle = layer.getModel(this.filesResult[0].children[0].id);
                var firstPid = null;
                if (firstModle && firstModle.userData) {
                    firstPid = firstModle.userData.pid;
                }
                var config = {
                    id: this.filesResult[0].children[0].id,
                    tableName: this.filesResult[0].children[0].tableName,
                    objType: this.filesResult[0].objType,
                    productName: this.filesResult[0].name,
                    pid: firstPid
                };
                this.props.parent.setState({
                    openKeys: [this.filesResult[0].objType],
                    current: [this.filesResult[0].children[0].id]
                });
                _Events2.default.emit('reloadDetail', config);
                this.props.parent.initialize = false;
            }
        }
    }, {
        key: 'getObjTypeList',
        value: function getObjTypeList() {
            this.layerList.forEach(function (e) {
                _Events2.default.emit('setRightMenu', e);
            });
        }
    }, {
        key: 'setModuleState',
        value: function setModuleState(moduleState) {
            if (moduleState.isCheck == true) {
                this.isCheck = true;
                this.objPid = moduleState.objPid;
            } else {
                this.isCheck = false;
                this.objPid = moduleState.objPid;
            }
        }
    }, {
        key: 'onSearchModule',
        value: function onSearchModule() {
            this.props.parent.onSearch = true;
            this.reloadData({ projectId: this.state.projectId, deviceName: this.state.deviceName });
        }
    }, {
        key: 'checkModule',
        value: function checkModule(e) {
            var item = {
                id: e.id,
                objType: e.objType
            };
            _Events2.default.emit('findModule', item);
        }
    }, {
        key: 'recursion',
        value: function recursion(dataSource) {
            var _this2 = this;

            return dataSource.map(function (menu, index) {
                if (menu.children) {
                    return _react2.default.createElement(
                        SubMenu,
                        { key: menu.objType, title: _react2.default.createElement(
                                'span',
                                { className: 'menuTitle' },
                                menu.name
                            ), className: 'gis-subMenu' },
                        _this2.recursion(menu.children)
                    );
                } else {
                    _this2.checkModule(menu);
                    return _react2.default.createElement(
                        _antd.Menu.Item,
                        { as: menu.tableName, key: menu.id, className: 'gis-menuItem', name: menu.productName, type: _this2.objPid },
                        _react2.default.createElement(
                            'span',
                            null,
                            _react2.default.createElement(_antd.Icon, { type: 'check', className: _this2.isCheck == true ? 'gis-isCheck' : 'gis-unCheck' }),
                            _react2.default.createElement(
                                'span',
                                null,
                                menu.name || "未知"
                            )
                        )
                    );
                }
            });
        }
    }, {
        key: 'onChangePage',
        value: function onChangePage(pageCurrent) {
            if (!this.locked) {
                var resultPage = this.filesResult.slice(15 * (pageCurrent - 1), 15 * (pageCurrent - 1) + 15);
                this.setState({ resultPage: resultPage, pageCurrent: pageCurrent });
            }
        }
    }, {
        key: 'clearInput',
        value: function clearInput() {
            this.setState({
                deviceName: "",
                isClear: false
            });
            this.storeConfig.deviceName = undefined;
            this.props.parent.onSearch = false;
            _Events2.default.emit('reloadListBar');
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var deviceName = this.state.deviceName;

            var gisIcon = _react2.default.createElement(_antd.Icon, { onClick: this.clearInput.bind(this), type: 'close-circle', theme: 'filled', style: { color: '#ABD1FF' }, className: this.state.isClear == true ? "gis-input-suffix" : "gis-hide" });
            return _react2.default.createElement(
                'div',
                { className: 'gis-searchGrid' },
                _react2.default.createElement(
                    'div',
                    { className: 'gis-searchDiv' },
                    _react2.default.createElement(_antd.Input, { placeholder: '\u8F93\u5165\u8BBE\u5907\u540D\u79F0\u641C\u7D22',
                        value: deviceName,
                        onChange: this.onChangeModuleName,
                        ref: function ref(node) {
                            return _this3.moduleNameInput = node;
                        },
                        className: 'gis-searchInput',
                        suffix: gisIcon
                    }),
                    _react2.default.createElement(
                        _antd.Button,
                        {
                            type: 'primary',
                            onClick: this.onSearchModule.bind(this),
                            className: 'gis-searchButton' },
                        '\u67E5\u8BE2'
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'gis-searchMenu' },
                    _react2.default.createElement(
                        'span',
                        { className: 'gis-listTitle' },
                        '\u8BBE\u5907\u5217\u8868'
                    ),
                    _react2.default.createElement(
                        _antd.Menu,
                        {
                            mode: 'inline',
                            theme: 'dark',
                            openKeys: this.props.parent.state.openKeys,
                            onOpenChange: this.onOpenChange,
                            onClick: this.handleClick,
                            selectedKeys: this.props.parent.state.current,
                            className: 'gis-listMenu'
                        },
                        this.state ? this.recursion(this.state.resultPage || []) : null
                    ),
                    _react2.default.createElement(_antd.Pagination, {
                        current: this.state.pageCurrent,
                        total: this.filesResult.length,
                        PageSize: 15,
                        showTotal: function showTotal(total) {
                            return '\u5171' + total + '\u6761';
                        },
                        size: 'small',
                        onChange: this.onChangePage.bind(this),
                        className: 'gis-listPagination'
                    })
                )
            );
        }
    }]);

    return DeviceListBar;
}(_react2.default.Component);

exports.default = DeviceListBar;