'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DeviceDetil = require('./DeviceDetil');

var _DeviceDetil2 = _interopRequireDefault(_DeviceDetil);

var _DeviceListBar = require('./DeviceListBar');

var _DeviceListBar2 = _interopRequireDefault(_DeviceListBar);

var _MapSite = require('./MapSite');

var _MapSite2 = _interopRequireDefault(_MapSite);

var _Events = require('./util/Events');

var _Events2 = _interopRequireDefault(_Events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require("./Main.css");

var Main = function (_React$Component) {
    _inherits(Main, _React$Component);

    function Main() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Main);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Main.__proto__ || Object.getPrototypeOf(Main)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            error: false,
            checkModule: true
        }, _this.locked = false, _this.initialize = true, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Main, [{
        key: 'componentWillMount',
        value: function componentWillMount() {}
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.errorTipsFn = this.errorTips.bind(this);
            _Events2.default.addListener('errorTips', this.errorTipsFn);
            if (!this.locked) {
                window.earth.on('EarthFinish', function () {
                    //地图加载完成
                    if (window.earth) {
                        window.earth.Api.Light.updateAmbientLight({ color: '#FFFFFF', intensity: 3 });
                        window.earth.confg.ClickColor = "fff900";
                    }
                });
            };
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            _Events2.default.removeListener('errorTips', this.errorTipsFn);
            if (window.earth) {
                window.earth.dispose();
                window.earth = undefined;
            }
            this.locked = true;
        }
    }, {
        key: 'errorTips',
        value: function errorTips() {
            this.setState({ error: true });
        }
    }, {
        key: 'render',
        value: function render() {
            var token = this.props.token || null;
            var listCfg = {
                url: this.props.Info + ('?access_token=' + token), //access_token
                projectId: this.props.Projects.id
            };
            var detailCfg = {
                url: this.props.Detail + ('?access_token=' + token),
                save_url: this.props.Save + ('?access_token=' + token),
                delete_url: this.props.Delete + ('?access_token=' + token)
            };
            var earthCfg = this.props.Projects;
            return _react2.default.createElement(
                'div',
                null,
                this.state.error == false ? _react2.default.createElement(
                    'div',
                    { className: 'gis-main' },
                    _react2.default.createElement(_MapSite2.default, _extends({}, _extends(earthCfg), { parent: this })),
                    _react2.default.createElement(
                        'div',
                        { className: 'gis-leftBar' },
                        _react2.default.createElement(
                            'div',
                            null,
                            _react2.default.createElement(_DeviceListBar2.default, _extends({}, _extends(listCfg), { parent: this }))
                        )
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'gis-rightMain' },
                        _react2.default.createElement(
                            'div',
                            { className: 'gis-topDetail' },
                            _react2.default.createElement(_DeviceDetil2.default, _extends({}, _extends(detailCfg), { parent: this }))
                        )
                    )
                ) : null,
                this.state.error == true ? _react2.default.createElement(
                    'div',
                    { className: 'gis-errorMain' },
                    _react2.default.createElement(
                        'div',
                        { className: 'gis-errorDiv' },
                        _react2.default.createElement(
                            'h1',
                            { className: 'gis-errorTitle' },
                            '\u8BBE\u5907\u5173\u8054\u672A\u5B8C\u6210'
                        ),
                        _react2.default.createElement(
                            'span',
                            { className: 'gis-errorTips' },
                            '\u8BBE\u5907\u5173\u8054\u672A\u5B8C\u6210\uFF0C\u8BF7\u8054\u7CFB\u7BA1\u7406\u5458\u4E3A\u8BE5\u9879\u76EE\u5173\u8054\u65B0\u8BBE\u5907'
                        ),
                        _react2.default.createElement(
                            'span',
                            { className: 'gis-errorAdmin' },
                            '\u7BA1\u7406\u5458\uFF1A18863103835'
                        )
                    )
                ) : null
            );
        }
    }]);

    return Main;
}(_react2.default.Component);

exports.default = Main;