'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Utils = require('./util/Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _EditModule = require('./EditModule');

var _EditModule2 = _interopRequireDefault(_EditModule);

var _Events = require('./util/Events');

var _Events2 = _interopRequireDefault(_Events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require("./Main.css");

var MapSite = function (_React$Component) {
    _inherits(MapSite, _React$Component);

    function MapSite() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, MapSite);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MapSite.__proto__ || Object.getPrototypeOf(MapSite)).call.apply(_ref, [this].concat(args))), _this), _this.exit = false, _this.module = null, _this.angle = null, _this.state = {
            isEditModule: false
        }, _this.locked = false, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(MapSite, [{
        key: 'componentWillMount',
        value: function componentWillMount() {}
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.reloadMap(this.props);
            this.findModuleFn = this.findModule.bind(this);
            this.isAddModuleFn = this.isAddModule.bind(this);
            this.setRightMenuFn = this.setRightMenu.bind(this);
            _Events2.default.addListener('findModule', this.findModuleFn);
            _Events2.default.addListener('isAddModule', this.isAddModuleFn);
            _Events2.default.addListener('setRightMenu', this.setRightMenuFn);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            _Events2.default.removeListener('findModule', this.findModuleFn);
            _Events2.default.removeListener('isAddModule', this.isAddModuleFn);
            _Events2.default.removeListener('setRightMenu', this.setRightMenuFn);
            this.locked = true;
        }
    }, {
        key: 'setCfg',
        value: function setCfg(data) {
            var lookatPoint = null;
            if (data.lookat != "") {
                var result = data.lookat.split(",");
                lookatPoint = new earth.Api.Type.Point(result[0] * 1, result[1] * 1);
            } else {
                lookatPoint = {};
            }
            var cfg = {
                EngineIP: data.engineip,
                ResourcesIP: data.resourcesip,
                LookAt: lookatPoint,
                polarAngle: 88
            };
            _extends(cfg, { hideBGTile: true, hideSky: false });
            return cfg;
        }
    }, {
        key: 'reloadMap',
        value: function reloadMap(data) {
            var cfg = {
                dom: document.getElementById('glCanvas'),
                key: 'wSryzKApfH8y'
            };
            if (!window.earth) {
                window.earth = new Earth(cfg);
                cfg = this.setCfg(data);
                window.earth.changeConfig(cfg);
                this.listenModuleState();
            } else {
                cfg = this.setCfg(data);
                window.earth.changeConfig(cfg);
                this.listenModuleState();
            }
        }
    }, {
        key: 'listenModuleState',
        value: function listenModuleState() {
            if (!this.locked && earth) {
                var me = this;
                window.earth.on('EarthFinish', function () {
                    _Events2.default.emit('reloadListBar');
                    if (earth) {
                        window.earth.Api.Inner.info(function (innerInfo) {
                            _Events2.default.emit('getOptionData', innerInfo);
                        }, me);
                    }
                });
                window.earth.on('MeshSaveState', function (geo) {
                    me.getModulePosition(geo);
                });
                window.earth.on('MeshClick', function (geo) {
                    console.log(geo);
                });
            }
        }
    }, {
        key: 'createItem',
        value: function createItem(text) {
            var menuDiv = document.createElement("div");
            menuDiv.className = 'gis-rightMenuItem';
            var menuSpan = document.createElement("span");
            menuSpan.innerHTML = text;
            menuSpan.style.cssText = 'cursor: pointer;';
            menuDiv.appendChild(menuSpan);
            return menuDiv;
        }
    }, {
        key: 'setRightMenu',
        value: function setRightMenu(objType) {
            var backgroundDiv = document.createElement("div");
            backgroundDiv.className = 'gis-rightMenuDiv';
            var deleteDiv = this.createItem("删除设备");
            deleteDiv.event = { type: 'click', fn: this.deleteModel.bind(this) };
            backgroundDiv.appendChild(deleteDiv);
            earth.Api.Menus.setMenu(objType, backgroundDiv);
        }
    }, {
        key: 'getModulePosition',
        value: function getModulePosition(geo) {
            var point = new window.earth.Api.Type.Point(geo.position.x, geo.position.y, geo.position.z, "3857");
            var modulePosition = point.clone().changeEPSGType('4326');
            _Events2.default.emit('saveModuleData', modulePosition);
        }
    }, {
        key: 'findModule',
        value: function findModule(data) {
            var objtype = data.objType;
            var layer = window.earth.Api.Layers.getLayer(objtype);
            if (layer == null) {
                var config = {
                    isCheck: false,
                    objPid: ""
                };
                _Events2.default.emit('setModuleState', config);
            } else {
                var e = layer.getModel(data.id);
                if (e) {
                    var _config = {
                        isCheck: true,
                        objPid: e.userData.pid
                    };
                    _Events2.default.emit('setModuleState', _config);
                } else {
                    var _config2 = {
                        isCheck: false,
                        objPid: ""
                    };
                    _Events2.default.emit('setModuleState', _config2);
                }
            }
        }
    }, {
        key: 'isExistModule',
        value: function isExistModule(moduleData) {
            var objtype = moduleData.objType;
            if (!objtype) {
                _Utils2.default.alert("该类模型未配置！");
                return false;
            }
            var moduleLayer = window.earth.Api.Layers.getLayer(objtype);
            if (moduleLayer == null) {
                _Utils2.default.alert("该类模型未配置！");
                return false;
            } else {
                var data = moduleLayer.getModel(moduleData.id);
                if (data) {
                    this.exit = true;
                    this.module = data;
                }
            }
            return true;
        }
    }, {
        key: 'isAddModule',
        value: function isAddModule(moduleData) {
            if (!this.isExistModule(moduleData)) return;
            if (this.exit == true) {
                this.flyToModule(this.module);
            } else {
                this.addModule(moduleData);
            };
            this.module = null;
            this.exit = false;
        }
    }, {
        key: 'addModule',
        value: function addModule(ele) {
            var _this2 = this;

            if (!this.locked) {
                if (this.props.parent.setModel) {
                    if (earth) {
                        this.props.parent.layerList.map(function (element) {
                            window.earth.Api.Layers.setObjVisible(element, []);
                        });
                        this.props.parent.setModel = ele;
                    }
                } else {
                    setTimeout(function () {
                        if (earth) {
                            _this2.props.parent.layerList.map(function (element) {
                                window.earth.Api.Layers.setObjVisible(element, []);
                            });
                            _this2.props.parent.setModel = ele;
                        }
                    }, 1000);
                }
            }
        }
    }, {
        key: 'flyToModule',
        value: function flyToModule(geo) {
            var _this3 = this;

            if (!this.locked) {
                setTimeout(function () {
                    if (earth) {
                        _this3.props.parent.layerList.map(function (element) {
                            window.earth.Api.Layers.setObjVisible(element, [geo.userData.id]);
                            geo.changeColor('#fff900');
                        });
                        window.earth.Api.Camera.lookAt(geo.parent.userData.objType, geo.userData.id, false);
                    }
                }, 1000);
                this.props.parent.lastAddModel = undefined;
                this.props.parent.setModel = undefined;
                this.props.parent.creatPop = false;
            }
        }
    }, {
        key: 'deleteModel',
        value: function deleteModel() {
            earth.Api.MeshInfo.doDelete();
            _Events2.default.emit('removeModuleData');
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                { id: 'glCanvas', className: 'gis-glCanvas' },
                this.state.isEditModule == true ? _react2.default.createElement(_EditModule2.default, { parent: this }) : null
            );
        }
    }]);

    return MapSite;
}(_react2.default.Component);

exports.default = MapSite;