"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _antd = require("antd");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 系统辅助类
 */
var Utils = function () {
    function Utils() {
        _classCallCheck(this, Utils);
    }

    _createClass(Utils, null, [{
        key: "isEmpty",

        /**
         * 判断是否为空
         * @param {字符串} str
         */
        value: function isEmpty(str) {
            if (str == null || str.length == 0) return true;
            return false;
        }
    }, {
        key: "isNull",
        value: function isNull(str) {
            if (str == "") return true;
            var regu = "^[ ]+$";
            var re = new RegExp(regu);
            return re.test(str);
        }

        /**
          * 判断小数点
          * */

    }, {
        key: "isContains",
        value: function isContains(str, substr) {
            if (!Utils.isEmpty(str)) {
                var string = str.toString();
                var last = string.substring(string.length - 1);
                return last.indexOf(substr) >= 0;
            }
        }

        /**
         * 获取token
         */

    }, {
        key: "getToken",
        value: function getToken() {
            return window.sessionStorage.getItem("ddmap_token");
        }
    }, {
        key: "setToken",

        /** 设置token */
        value: function setToken(token) {
            window.sessionStorage.setItem("ddmap_token", token);
        }
    }, {
        key: "alert",

        /**
         * 提示框
         * @param {提示内容} m
         */
        value: function alert(m) {
            _antd.message.info(m);
        }
    }, {
        key: "error",

        /**
         * 失败
         * @param message
         */
        value: function error(m) {
            _antd.message.error(m);
        }

        /**
         * 警告
         * @param message
         */

    }, {
        key: "warning",
        value: function warning(m) {
            _antd.message.warning(m);
        }
    }, {
        key: "success",
        value: function success(m) {
            _antd.message.success(m);
        }

        /**
         * 判断返回数据是否成功
         * @param {返回数据} data
         */

    }, {
        key: "isSuccess",
        value: function isSuccess(data) {
            if (data.errorCode) {
                _antd.message.error(data.message);
                return false;
            }
            return true;
        }
    }, {
        key: "getSecretKey",


        /**
         * 获取secretKey
         */
        value: function getSecretKey() {
            return window.sessionStorage.getItem("ddmap_secretKey");
        }
    }, {
        key: "setSecretKey",

        /** 设置secretKey */
        value: function setSecretKey(key) {
            window.sessionStorage.setItem("ddmap_secretKey", key);
        }
    }, {
        key: "formatNum",

        /**
         * 参数说明：
         * s：要格式化的数字
         * n：保留几位小数
         * */
        value: function formatNum(s, n) {
            n = n > 0 && n <= 20 ? n : 2;
            s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
            var l = s.split(".")[0].split("").reverse(),
                r = s.split(".")[1];
            var t = "";
            for (var i = 0; i < l.length; i++) {
                t += l[i] + ((i + 1) % 3 == 0 && i + 1 != l.length ? "," : "");
            }
            return t.split("").reverse().join("") + "." + r;
        }
        /** 获取UUID */

    }, {
        key: "getUUID",
        value: function getUUID() {
            var len = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 32;

            var radix = 16;
            var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
            var uuid = [],
                i = void 0;
            radix = radix || chars.length;
            if (len) {
                for (i = 0; i < len; i++) {
                    uuid[i] = chars[0 | Math.random() * radix];
                }
            } else {
                var r;
                uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
                uuid[14] = '4';
                for (i = 0; i < 36; i++) {
                    if (!uuid[i]) {
                        r = 0 | Math.random() * 16;
                        uuid[i] = chars[i == 19 ? r & 0x3 | 0x8 : r];
                    }
                }
            }
            return uuid.join('');
        }
    }]);

    return Utils;
}();

exports.default = Utils;