import React from 'react';
import { Select } from 'antd';
import Request from './util/Request';
import Utils from './util/Utils';
import Emitter from './util/Events';
const Option = Select.Option;
class DeviceCombox extends React.Component {
    project={};
    state = {};
    componentWillMount() {
        let url = this.props.url;
        Request.get(url, null, this.getDataSuccess, this);
    };

    getDataSuccess(value) {
        if (!Utils.isSuccess(value))
            return;
        this.setState({ values: value.data});
        this.project = value.data[0];    
        Emitter.emit('reloadListBar', {projectId: this.project.id});
        Emitter.emit('reloadMapSite', this.project);
    };

    handleChange(value){
        this.state.values.forEach(data => {
            if(data.id == value){
                this.project = data;
            }
        });
        Emitter.emit('reloadListBar', {projectId: this.project.id});
        Emitter.emit('resetFields');
        Emitter.emit('reloadMapSite', this.project);
    };
   
    render() {
        let combox = {width: '100%',marginBottom:'10px'}
        const values = this.state.values;
        return (
            <div>
                <Select placeholder={values != null? values[0].name:null} style={combox} onChange={this.handleChange.bind(this)}>
                    {values != null ? values.map((data) => <Option key={data.id} value={data.id}>{data.name}</Option>) : null}
                </Select>
            </div>
        );
    }
}

export default DeviceCombox;
