import React from "react";
import { Form, Input, Button, Row, Col, Select } from 'antd';
import Utils from './util/Utils';
import Request from './util/Request';
import Emitter from './util/Events';
require("./Main.css");
const FormItem = Form.Item;
const Option = Select.Option;
// const { Option, OptGroup } = Select;
export default class DeviceDetil extends React.Component {
    state = {
        isEdit: false,
        isFlyTo: true,
        rotateAngle: null,
        innerInfoData: []
    };
    componentWillMount() { }
    initDetailDataFn;
    mateModuleFn;
    saveModuleDataFn;
    resetFieldsFn;
    removeModuleFn;
    getOptionDataFn;
    locked = false;
    resetObj = null;
    firstFloorId = null;
    componentDidMount() {
        this.initDetailDataFn = this.initDetailDataCall.bind(this);
        Emitter.addListener('reloadDetail', this.initDetailDataFn);
        this.mateModuleFn = this.mateModule.bind(this);
        Emitter.addListener('mateModule', this.mateModuleFn);
        this.saveModuleDataFn = this.saveModuleData.bind(this);
        Emitter.addListener('saveModuleData', this.saveModuleDataFn);
        this.resetFieldsFn = this.resetFields.bind(this);
        Emitter.addListener('resetFields', this.resetFieldsFn);
        this.removeModuleFn = this.removeModule.bind(this);
        Emitter.addListener('removeModuleData', this.removeModuleFn);
        this.getOptionDataFn = this.getOptionData.bind(this);
        Emitter.addListener('getOptionData', this.getOptionDataFn);
    };
    componentWillUnmount() {
        Emitter.removeListener('reloadDetail', this.initDetailDataFn);
        Emitter.removeListener('removeModuleData', this.removeModuleFn);
        Emitter.removeListener('resetFields', this.resetFieldsFn);
        Emitter.removeListener('saveModuleData', this.saveModuleDataFn);
        Emitter.removeListener('mateModule', this.mateModuleFn);
        Emitter.removeListener('getOptionData', this.getOptionDataFn);
        this.locked = true;
    };
    initDetailDataCall(config) {
        if (!this.locked) {
            this.setState({ isEdit: false });
            this.initDetailData(config);
        }
    }
    doSubmit(earth) {
        let me = this;
        var reg = /^[^\s]*$/;
        let reg_1 = /^[^.();<>]*$/;
        if (me.formData['position']) {
            if (me.formData['position'].length > 20) {
                Utils.error("设备位置长度不能超过20！");
                return;
            }
            if (!reg.test(me.formData['position'])) {
                Utils.error("设备位置不能包含空格！");
                return;
            }
            if (!reg_1.test(me.formData['position'])) {
                Utils.error("设备位置不能特殊字符！");
                return;
            }
        }
        if ((me.formData['x'] * 1) + "" == "NaN") {
            Utils.error("经度栏请输入正确数字");
            return;
        }
        if ((me.formData['y'] * 1) + "" == "NaN") {
            Utils.error("纬度栏请输入正确数字");
            return;
        }
        if ((me.formData['z'] * 1) + "" == "NaN") {
            Utils.error("高度栏请输入正确数字");
            return;
        }
        if (me.formData['deviceAngle']) {
            if ((me.formData['deviceAngle'] * 1) + "" == "NaN") {
                Utils.error("设备角度只能为数值");
                return;
            }
        }
        if (me.formData['scalingRatio']) {
            if ((me.formData['scalingRatio'] * 1) + "" == "NaN") {
                Utils.error("设备缩放比例只能为数值");
                return;
            }
        }
        me.formProps.form.validateFields((err, values) => {
            if (!Utils.isEmpty(err))
                return;
            let param = {};
            Object.keys(me.formData).map((k) => {
                param[k] = me.formData[k];
            });
            if (!earth) {
                var m = window.earth.Api.Layers.getLayer(param.objType).getModel(param.id);
                var point = new window.earth.Api.Type.Point(parseFloat(param.x), parseFloat(param.y), parseFloat(param.z));
                point.changeEPSGType('3857');
                m.setPosition(point);
                m.userData.repeat_rate = param.scalingRatio + ',' + param.scalingRatio + ',' + param.scalingRatio;
                m.userData.angle = param.deviceAngle;
                m.userData.pid = param.pid;
                if (param.deviceAreaType == "public") {
                    m.userData.type = 1;
                } else {
                    m.userData.type = 0;
                }
                let select = window.earth.getControl('SelectControl');
                select.doUnSelect();
                select.doSelect({ object: m, point: m.position.clone() });
                window.earth.Api.MeshInfo.doEdit();
            } else {
                let url = me.props.save_url;
                Request.post(url, param, null, me.callbackSubmit.bind(this), me);
            }
        });
        this.setState({ isEdit: false, readonly: true });
        this.props.parent.lastAddModel = undefined;
        this.props.parent.creatPop = false;
        this.props.parent.setModel = undefined;
        window.earth.Api.MeshInfo.endMove();
        window.earth.Api.Pop.clear(this.formData.objType, this.formData.id);
    };
    callbackSubmit(data) {
        if (Utils.isSuccess(data)) {
            Utils.success('保存成功!');
            this.resetObj = Object.assign({}, this.formData);
            Emitter.emit('reloadListBar');
        } else {
            Utils.error('保存失败!');
        };
    };

    removeModule() {
        let me = this;
        let url = me.props.delete_url;
        let params = new FormData();
        params.append('id', me.formData['id']);
        params.append('tableName', me.formData['table_name']);
        Request.post(url, params, null, me.callbackDelete, me);
    };

    callbackDelete(data) {
        if (Utils.isSuccess(data)) {
            Utils.success('删除成功!');
            this.formData = {};
            this.props.parent.setState({ current: [] });
            this.props.parent.lastAddModel = undefined;
        } else {
            Utils.error('删除失败!');
        };
        this.resetFields();
        Emitter.emit('reloadListBar');
    };

    resetFields() {
        this.formProps.form.resetFields();
    };

    resetForm() {
        let value = {};
        let obj = this.resetObj;
        value['position'] = obj.position;
        value['x'] = obj.x ? parseFloat(obj.x).toFixed(6) : null;
        value['y'] = obj.y ? parseFloat(obj.y).toFixed(6) : null;
        value['z'] = obj.z ? parseFloat(obj.z).toFixed(2) : null;
        value['deviceAngle'] = obj.deviceAngle;
        value['scalingRatio'] = obj.scalingRatio;
        this.formProps.form.setFieldsValue(value);
    }

    saveModuleData(position) {
        let value = {};
        value['x'] = position.x;
        value['y'] = position.y;
        value['z'] = position.z;
        this.formProps.form.setFieldsValue(value);
        this.doSubmit(true);
    };

    mateModule(geo) {
        if (!this.locked) {
            this.setState({ isEdit: false, readonly: true });
            var point = new window.earth.Api.Type.Point(geo.position.x, geo.position.y, geo.position.z, '3857');
            point.changeEPSGType('4326');
            let config = {
                id: geo.userData.id,
                objType: geo.parent.userData.objType,
                x: point.x,
                y: point.y,
                z: point.z,
                deviceAngle: geo.userData.angle,
                scalingRatio: geo.userData.repeat_rate.split(",")[0],
            }
            this.setState({ isFlyTo: false });
            this.initDetailData(config);
            this.props.parent.setState({
                openKeys: [geo.parent.userData.objType],
                current: [geo.userData.id],
            });
            this.props.parent.onSearch = false;
            let layer = document.getElementById(geo.parent.userData.objType + '$Menu');
            if (layer == undefined) {
                Utils.alert('请重新选择设备类型');
            } else {
                let layerList = layer.getElementsByClassName('ant-menu-item-selected')[0];
                var i = 0;
                while ((layerList = layerList.previousSibling) != null) i++;
                layer.scrollTo(0, i * 35);
            }
            Emitter.emit('reloadListBar');
        }
    };
    initDetailData(config) {
        let url = this.props.url;
        for (let key in config) {
            let v = config[key];
            if (!Utils.isEmpty(v))
                url += `&${key}=${v}`;
        }
        Request.get(url, null, this.getDataSuccess.bind(this, config), this);
    }

    getDataSuccess(config, value) {
        if (!this.locked) {
            if (!Utils.isSuccess(value))
                return;
            let module_data = value.data;
            if (!module_data) {
                Utils.alert('无相关数据!');
                return;
            }
            Object.assign(value.data, config);
            this.formData = value.data || {};
            if (Utils.isEmpty(this.formData['deviceAngle'])) {
                this.formData['deviceAngle'] = 0;
            }
            if (Utils.isEmpty(this.formData['scalingRatio'])) {
                this.formData['scalingRatio'] = 1;
            }
            this.resetObj = Object.assign({}, this.formData);
            this.setState({ rotateAngle: value.data.deviceAngle });
            this.setState({ readonly: true });
            this.onFieldsChange(null, null);
            if (this.state.isFlyTo == true) {
                Emitter.emit('isAddModule', module_data);
            } else {
                this.setState({ isFlyTo: true });
            }
        }
        window.earth.Api.MeshInfo.endMove();
    };

    getOptionData(innerInfo) {
        this.setState({ innerInfoData: innerInfo.values });
    };

    creatOption() {
        let listData = this.state.innerInfoData;
        return (
            listData.map((ele) => {
                if (ele.high == "0") {
                    this.firstFloorId = ele.id;
                }
                return (
                    <Option key={ele.id} value={ele.id}>家庭区域-{ele.name}</Option>
                )
            })
        )
    }

    mapPropsToFields() {
        if (!this.formData) {
            this.formData = this.initFormData();
        }
        Object.assign(this.formData);
        let config = {};
        Object.keys(this.formData).map((k) => {
            if (k == 'x' || k == 'y') {
                this.formData[k] = (this.formData[k] * 1).toFixed(6);
            } else if (k == 'z' || k == 'scalingRatio') {
                this.formData[k] = (this.formData[k] * 1).toFixed(2);
            }
            config[k] = Form.createFormField({ value: this.formData[k] });
        });
        return config;
    };

    initFormData() {
        return {};
    };
    onValuesChange(_, values) {
        Object.assign(this.formData, values);
    };
    onFieldsChange(props, changedFields) {
    };

    initForm() {
        const cfg = {
            onFieldsChange: this.onFieldsChange.bind(this),
            mapPropsToFields: this.mapPropsToFields.bind(this),
            onValuesChange: this.onValuesChange.bind(this)
        };
        const CustomizedForm = Form.create(cfg)((props) => {
            this.initRuleConfig(props);
            this.initRuleFunc(props);
            this.formProps = props;
            return this.initDetail(props);
        });
        return <CustomizedForm />;
    };

    doEdit() {
        if (!this.locked) {
            this.setState({ isEdit: true, readonly: false });
        }
        if (this.props.parent.setModel) {
            let point = null;
            let ele = this.props.parent.setModel;
            if (Utils.isEmpty(ele.x) || Utils.isEmpty(ele.y) || Utils.isEmpty(ele.z)) {
                point = window.earth.Api.Camera.info().target;
                point.z = 50;
            } else {
                point = new window.earth.Api.Type.Point(ele.x * 1, ele.y * 1, ele.z * 1);
            }
            let shapes = [];
            let cfg = {};
            shapes = [point];
            cfg = {
                data: {
                    id: ele.id,
                    fbx: './images/equipment/' + ele.objType + '.fbx',
                    angle: "0",
                    repeat_rate: "1,1,1",
                    rotatex: "1",
                },
                jsType: "Fbx",
                shapes: shapes,
            }
            let fbx = new window.earth.Api.Models.Fbx(cfg, earth);
            let layer = window.earth.Api.Layers.getLayer(ele.objType);
            this.props.parent.lastAddModel = {
                objType: ele.objType,
                id: ele.id
            };
            layer.add(fbx);
            setTimeout(() => {
                if (earth) {
                    fbx.changeColor('#fff900');
                    window.earth.Api.Camera.lookAt(ele.objType, ele.id, false);
                }
            }, 1000);
        }
        this.props.parent.creatPop = true;
        let me = this;
        window.earth.on('MeshHover', function (ele) {
            if (ele.userData.id == me.formData.id && me.props.parent.creatPop) {
                window.earth.Api.Pop.setObjPop(ele.parent.userData.objType, ele.userData.id, function (result) {
                    result.innerHTML = '<div class="gis-modelPop"><span>请拖动设备到目标位置</span><i></i></div>';
                });
                window.earth.Api.Pop.display(ele.parent.userData.objType, ele.userData.id, true);
            }
            if (document.querySelector('.gis-modelPop')) {
                document.querySelector('.gis-modelPop').parentNode.style.cssText += 'pointer-events: none;'
            }
        });
        window.earth.on('MeshUnHover', function (ele) {
            if (ele.userData.id == me.formData.id && me.props.parent.creatPop) {
                window.earth.Api.Pop.clear(ele.parent.userData.objType, ele.userData.id);
            }
        });
        window.earth.Api.MeshInfo.doMove(false);
    }
    changeType(value) {
        if (value !== "public") {
            this.formData['deviceAreaType'] = "house";
            this.formData['pid'] = value;
        } else {
            this.formData['deviceAreaType'] = value;
            this.formData['pid'] = this.firstFloorId;
        }
    }
    changePosition(data) {
        let m = window.earth.Api.Layers.getLayer(this.formData['objType']).getModel(this.formData['id']);
        let point = new window.earth.Api.Type.Point(parseFloat(this.formData['x']), parseFloat(this.formData['y']), parseFloat(this.formData['z']));
        point.changeEPSGType('3857');
        m.setPosition(point);
        if (data == 'deviceAngle') {
            let angle = this.formData['deviceAngle'] * 1;
            let beforeAngle;
            if (this.state.rotateAngle) {
                beforeAngle = this.state.rotateAngle * 1;
            } else {
                beforeAngle = 0;
            }
            if (angle >= 0 && angle <= 360 && Math.floor(angle) === angle) {
                let value = (angle - beforeAngle) * Math.PI / 180;
                this.setState({ rotateAngle: this.formData['deviceAngle'] });
                m.rotateY(value);
            } else {
                Utils.error("设备角度为0度至360度之间的整数");
                return;
            }
        }
        if (data == 'scalingRatio') {
            let rate = this.formData['scalingRatio'] * 1;
            m.scale.set(rate, rate, rate);
        }
    }
    changeProperty(field, e) {
        if (field == 'x') {
            if ((e.target.value * 1 + "") != "NaN") {
                this.changePosition();
            } else {
                Utils.error("请输入数值");
                return;
            }
        } else if (field == 'y') {
            if ((e.target.value * 1 + "") != "NaN") {
                this.changePosition();
            } else {
                Utils.error("请输入数值");
                return;
            }
        } else if (field == 'z') {
            if ((e.target.value * 1 + "") != "NaN") {
                this.changePosition();
            } else {
                Utils.error("请输入数值");
                return;
            }
        } else if (field == 'deviceAngle') {
            if ((e.target.value * 1 + "") != "NaN") {
                this.changePosition('deviceAngle');
            } else {
                Utils.error("请输入数值");
                return;
            }
        } else if (field == 'scalingRatio') {
            if ((e.target.value * 1 + "") != "NaN") {
                this.changePosition('scalingRatio');
            } else {
                Utils.error("请输入数值");
                return;
            }
        }
    }
    setDefault() {
        if (this.formData['deviceAreaType'] == "house") {
            return this.formData["pid"];
        } else {
            return this.formData['deviceAreaType'];
        }
    }
    initDetail(props) {
        const { initFieldStates } = props.form;
        return (
            <section style={{ padding: 24 }}>
                <Form className={this.state.isEdit == false ? 'gis-editState' : 'gis-saveState'}>
                    <Row>
                        <Col span={4}>
                            <FormItem>
                                {initFieldStates('name', { dom: Input, style: { width: 210, height: 28 } })}
                            </FormItem>
                        </Col>
                    </Row>
                    <Row>
                        <Col span={5}>
                            <FormItem>
                                <label className='gis-formLabel'>产品名称：</label>
                                {initFieldStates('productName', { dom: Input, style: { width: 210, height: 28 } })}
                            </FormItem>
                        </Col>
                        <Col span={10}>
                            <FormItem>
                                <label className='gis-formLabel'>设备ID：</label>
                                {initFieldStates('id', { dom: Input, style: { width: 300, height: 28 } })}
                            </FormItem>
                        </Col>
                        <Col span={9}>
                            <FormItem>
                                <label className='gis-formLabel'>设备位置：</label>
                                <Select defaultValue={this.setDefault()} id='deviceAreaType' onChange={this.changeType.bind(this)} dropdownClassName='areaType' disabled={this.state.isEdit == false ? true : false} >
                                    <Option value="public">公共区域</Option>
                                    {this.creatOption()}
                                </Select>
                                <span id='selectLink'>-</span>
                                {initFieldStates('position', { dom: Input, style: { width: '45%', height: 28 } })}
                            </FormItem>
                        </Col>
                    </Row>
                    <Row>
                        <Col span={5}>
                            <FormItem>
                                <label className='gis-formLabel'>经度：</label>
                                <div onBlur={this.changeProperty.bind(this, 'x')}>
                                    {initFieldStates('x', { dom: Input, style: { width: '80%', height: 28 } })}
                                </div>
                            </FormItem>
                        </Col>
                        <Col span={5}>
                            <FormItem>
                                <label className='gis-formLabel'>纬度：</label>
                                <div onBlur={this.changeProperty.bind(this, 'y')}>
                                    {initFieldStates('y', { dom: Input, style: { width: '80%', height: 28 } })}
                                </div>
                            </FormItem>
                        </Col>
                        <Col span={5}>
                            <FormItem>
                                <label className='gis-formLabel'>高度：</label>
                                <div onBlur={this.changeProperty.bind(this, 'z')}>
                                    {initFieldStates('z', { dom: Input, style: { width: '80%', height: 28 } })}
                                </div>
                            </FormItem>
                        </Col>
                        <Col span={5} style={{ width: '16.87%' }}>
                            <FormItem>
                                <label className='gis-formLabel'>设备角度：</label>
                                <div onBlur={this.changeProperty.bind(this, 'deviceAngle')}>
                                    {initFieldStates('deviceAngle', { dom: Input, style: { width: '100%', height: 28 } })}
                                </div>
                            </FormItem>
                        </Col>
                        <Col span={4} style={{ width: '16.9%', marginLeft: '15.6px' }}>
                            <FormItem>
                                <label className='gis-formLabel'>缩放比例：</label>
                                <div onBlur={this.changeProperty.bind(this, 'scalingRatio')}>
                                    {initFieldStates('scalingRatio', { dom: Input, style: { width: '100%', height: 28 } })}
                                </div>
                            </FormItem>
                        </Col>
                    </Row>
                    <Row>
                        <Col span={4} offset={20} style={{ marginLeft: '80.7%', textAlign: 'right' }}>
                            {this.state.isEdit == false ? <Button type="primary" onClick={this.doEdit.bind(this)} className='gis-editButton'>编辑</Button> : null}
                            {this.state.isEdit == true ?
                                <div>
                                    <Button type="primary" onClick={this.doSubmit.bind(this, false)} className='gis-saveButton'>保存</Button>
                                    <Button onClick={this.resetForm.bind(this)} className='gis-resetButton'>重置</Button>
                                </div>
                                : null}
                        </Col>
                    </Row>
                </Form>
            </section>
        );
    };

    initRuleConfig(props) {
        props.form.rules = {};
        if (this.state.readonly == true) {
            props.form.rules['name'] = {};
            props.form.rules['name']['readonly'] = 1;
            props.form.rules['productName'] = {};
            props.form.rules['productName']['readonly'] = 1;
            props.form.rules['id'] = {};
            props.form.rules['id']['readonly'] = 1;
            props.form.rules['position'] = {};
            props.form.rules['position']['readonly'] = 1;
            props.form.rules['x'] = {};
            props.form.rules['x']['readonly'] = 1;
            props.form.rules['y'] = {};
            props.form.rules['y']['readonly'] = 1;
            props.form.rules['z'] = {};
            props.form.rules['z']['readonly'] = 1;
            props.form.rules['deviceAngle'] = {};
            props.form.rules['deviceAngle']['readonly'] = 1;
            props.form.rules['scalingRatio'] = {};
            props.form.rules['scalingRatio']['readonly'] = 1;
        }
        else {
            props.form.rules['name'] = {};
            props.form.rules['name']['readonly'] = 1;
            props.form.rules['productName'] = {};
            props.form.rules['productName']['readonly'] = 1;
            props.form.rules['id'] = {};
            props.form.rules['id']['readonly'] = 1;
        }
    };
    initRuleFunc(props) {
        const { getFieldDecorator } = props.form;
        props.form['initFieldStates'] = function (field, cls) {
            let rule = props.form.rules[field];
            let allowblank = rule != null ? rule.allowblank : 0;
            let readonly = rule != null ? rule.readonly : 0;

            return (
                getFieldDecorator(field, {
                    rules: [{ required: allowblank == 1, message: '字段不能为空' }]
                })(<cls.dom style={cls.style} disabled={readonly == 1} {...cls.cfg} />)
            );
        };
    };

    render() {
        return (
            <div>
                {this.initForm()}
            </div>
        );
    };
}