import React from 'react';
import { Modal, Input, Row, } from 'antd';
import Utils from './util/Utils';
require("./Main.css");
class EditModule extends React.Component {
    module = null;
    state = {
        modelId: '',
        modelRepeatRate: ''
    }
    componentWillMount() {
        this.userData = {};
        this.getDataInfo();
    };
    getDataInfo() {
        if (this.props.parent.state.geo) {
            this.module = this.props.parent.state.geo;
            this.userData = this.props.parent.state.geo.userData;
            let str = this.userData.repeat_rate.split(",");
            this.setState({ modelRepeatRate: str[0] });
            this.setState({ modelId: this.userData.id });
        }
    }

    determine() {
        let zoom = document.getElementById("rate");
        if (zoom) {
            var re = /^[0-9]+.?[0-9]*$/;
            let modelZoomValue = zoom.value.replace(/\s+/g, "");
            if (!modelZoomValue) {
                return Utils.alert("设备缩放比不能为空！");
            } else if (!re.test(modelZoomValue)) {
                return Utils.alert("设备缩放比类型错误,请输入数字类型！");
            } else {
                if (modelZoomValue.indexOf('.') != -1) {
                    modelZoomValue = Utils.formatNum(modelZoomValue, 2);
                }
            }
            let modelObj = {};
            modelObj = this.props.parent.state.geo;
            modelObj.userData.repeat_rate = modelZoomValue + "," + modelZoomValue + "," + modelZoomValue;
            window.earth.Api.MeshInfo.doEdit();
            this.goBack();
        }

    }
    goBack() {
        this.props.parent.setState({ isEditModule: false, geo: {} });
    }
    modelRepeatRate(ele) {
        let inputValue = ele.target.value;
        let value = inputValue * 1;
        var re = /^[0-9]+.?[0-9]*$/;
        if (!re.test(value)) {
            Utils.alert("设备缩放比类型错误,请输入数字类型！");
        }
        this.setState({ modelRepeatRate: ele.target.value });
    }

    render() {
        return (
            <Modal
                title="设置缩放比"
                visible={true}
                width={350}
                okText="确定"
                cancelText="返回"
                onOk={this.determine.bind(this)}
                onCancel={this.goBack.bind(this)}
                className='gis-modalDiv'
                centered={true}
            >
                <Row style={{ marginBottom: 10 }}>
                    <label style={{ width: 90, display: 'inline-block' }}>设备缩放比：</label>
                    <Input id="rate" onChange={this.modelRepeatRate.bind(this)} value={this.state.modelRepeatRate ? this.state.modelRepeatRate : ""} style={{ width: 150 }} />
                </Row>
            </Modal>
        );
    }
}
export default EditModule;
