import React from 'react';
import DeviceDetil from './DeviceDetil';
import DeviceListBar from './DeviceListBar';
import MapSite from './MapSite';
import Emitter from './util/Events';
require("./Main.css");
class Main extends React.Component {
    state = {
        error: false,
        checkModule: true
    };
    errorTipsFn;
    locked = false;
    initialize = true;
    componentWillMount() { };

    componentDidMount() {
        this.errorTipsFn = this.errorTips.bind(this);
        Emitter.addListener('errorTips', this.errorTipsFn);
        if (!this.locked) {
            window.earth.on('EarthFinish', () => { //地图加载完成
                if (window.earth) {
                    window.earth.Api.Light.updateAmbientLight({ color: '#FFFFFF', intensity: 3 });
                    window.earth.confg.ClickColor = "fff900";
                }
            });
        };
    }
    componentWillUnmount() {
        Emitter.removeListener('errorTips', this.errorTipsFn);
        if (window.earth) {
            window.earth.dispose();
            window.earth = undefined;
        }
        this.locked = true;
    };
    errorTips() {
        this.setState({ error: true });
    }
    render() {
        let token = this.props.token || null;
        let listCfg = {
            url: this.props.Info + `?access_token=${token}`, //access_token
            projectId: this.props.Projects.id,
        };
        let detailCfg = {
            url: this.props.Detail + `?access_token=${token}`,
            save_url: this.props.Save + `?access_token=${token}`,
            delete_url: this.props.Delete + `?access_token=${token}`
        };
        let earthCfg = this.props.Projects;
        return (
            <div>
                {this.state.error == false ?
                    <div className='gis-main'>
                        <MapSite {...Object.assign(earthCfg)} parent={this} />
                        <div className='gis-leftBar'>
                            <div ><DeviceListBar {...Object.assign(listCfg)} parent={this} /></div>
                        </div>
                        <div className='gis-rightMain'>
                            <div className='gis-topDetail'><DeviceDetil {...Object.assign(detailCfg)} parent={this} /></div>
                        </div>
                    </div>

                    : null}
                {this.state.error == true ?
                    <div className='gis-errorMain'>
                        <div className='gis-errorDiv'>
                            <h1 className='gis-errorTitle'>设备关联未完成</h1>
                            <span className='gis-errorTips'>设备关联未完成，请联系管理员为该项目关联新设备</span>
                            <span className='gis-errorAdmin'>管理员：18863103835</span>
                        </div>
                    </div>
                    : null}
            </div>
        );
    }
}

export default Main;
