var fs = require("fs");
var path = require("path");
var webpack = require("webpack");
var ExtractTextPlugin = require("extract-text-webpack-plugin");
var EXAMPLES_DIR = path.resolve(__dirname, "dist");

var extractCSS = new ExtractTextPlugin("index.css");
var modulesDirectories = ["web_modules", "node_modules", "bower_components", "src"];
module.exports = {
  entry: { app: ['./src/index.css'] },
  output: {
    filename: "index.css",
    chunkFilename: "index.chunk.js",
    path: "lib"
  },
  resolve: {
    modulesDirectories: modulesDirectories,
    extensions: ['', '.js', '.jsx', '.css', '.scss']
  },
  module: {
    loaders: [
      {
        test: /\.(js|jsx)$/,
        exclude: /node_modules/,
        loader: "babel",
        query: {
          presets: ['react', 'latest', 'stage-2'],
          plugins: [
            [
              "import",
              {
                "libraryName": "antd",
                "style": "css"
              }
            ]
          ]
        }
      },
      {
        test: /\.(eot|woff|ttf|svg)/,
        loader: "file-loader?name=[name].[ext]"
      },
        {
            test: /\.css$/,
            loader: ExtractTextPlugin.extract('style', 'css')
        },
      {
        test: /\.html$/,
        loader: "html-loader"
      },
      {
        test: /\.png$/,
        loader: "file-loader?name=[name].[ext]"
      }
    ]
  },
  plugins: [extractCSS, new webpack.optimize.DedupePlugin()]
};
